#include "handle.inc"

#declare mug_body = union {
	object {
		torus { 3, 0.2
			translate <0, 7, 0>
		}
		texture { mug_tex }
	}
	difference {
		object {
			cylinder {
				<0, 0.15, 0>
				<0, 7, 0>
				3.2
			}
//			texture { mug_tex }
		}
		object {
			cylinder {
				<0, 0.14, 0>
				<0, 7.1, 0>
				2.8
			}
			texture { mug_tex }
		}
	}
	difference {
		object {
			torus {3, 0.2
				translate <0, 0.15, 0>
			texture { mug_tex }
			}
		}
		object {
			plane { <0, 1, 0> 0 }
			texture { mug_tex  finish { specular 0 reflection 0 } }
		}
	}
	difference {
		difference {
			object {
				cylinder {
					<0, 0.15, 0>
					<0, 0.35, 0>
					2.8
				}
				texture { mug_tex }
			}
			object {
				cylinder {
					<0, 0.14, 0>
					<0, 0.36, 0>
					2.6
				}
				texture { mug_tex }
			}
		}
		object {
			torus {2.6, 0.2
				translate <0, 0.15, 0>
			}
			texture { mug_tex }
		}
	}
	object {
		cylinder {
			<0, 0.35, 0>
			<0, 0.65, 0>
			2.8
		}
		texture { mug_tex }
	}
	bounded_by { cylinder { <0, 0, 0> <0, 7.2, 0> 3.2 } }
}


#declare mug = union {
	object { mug_body }
	object { mug_handle texture { mug_tex }
	 bounded_by {box {<3.2, 0.75, -0.25> <6, 6.3, 0.25>} } scale <1, 1, 2>}
	
}

#declare spoon_handle = intersection {
	cylinder {
		<-25, 0, 0>
		<-25, 10, 0>
		25.1
	}
	object { cylinder {
			<25, 0, 0>
			<25, 10, 0>
			25.1
		}
		texture {
			pigment { rgb <0.66, 0.66, 0.66> }
			finish {
				specular 1
				roughness 0.05
				metallic
				reflection 0.6
				ambient 0.3
				diffuse 0.5
			}
				normal {
				  	bump_map {
			  		tga "grantex.tga"
		  			bump_size 10
			  	}
			  	scale <10, 1, 1>
			  	rotate <90, 0, 90>
		  		translate <0, 0, -0.5>
		  	}
		}
	}
	cylinder {
		<0, 0, -24.5>
		<0, 10, -24.5>
		25
	}
	cylinder {
		<0, 0, 24.5>
		<0, 10, 24.5>
		25
	}
	texture { pigment { rgb <0.66, 0.66, 0.66> }
		  finish {
			specular 1
			roughness 0.05
			metallic
			reflection 0.6
			ambient 0.3
			diffuse 0.5
		  }
	}
}

#declare fullmug = union {
	object {
		mug
	}
	union{
		cylinder {
 			<0, 0.65, 0>
 			<0, 6, 0>
 			2.8
 		}
 		difference {
 			difference {
 				cylinder {
 					<0, 6, 0>
 					<0, 6.1, 0>
 					2.8
 				}
 				cylinder {
 					<0, 5.9, 0>
 					<0, 6.2, 0>
 					2.7
 				}
 			}
 			torus { 2.7, 0.2 translate <0, 6.2, 0> }
 		}
 		texture {
 			pigment { rgb <0.11, 0.07, 0> }
			finish { 
				reflection 0.25
				specular 1
				roughness 0.001
			}
		}
	}
	object {spoon_handle rotate <0, 0, -41> translate <-2.65, 1, 0>}

}
 	
 		
